package cn.ibizlab.eam.core.eam_pf.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.eam.core.eam_pf.domain.PFDept;
import cn.ibizlab.eam.core.eam_pf.filter.PFDeptSearchContext;
import cn.ibizlab.eam.core.eam_pf.service.IPFDeptService;

import cn.ibizlab.eam.util.helper.CachedBeanCopier;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.eam.core.eam_pf.mapper.PFDeptMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[部门] 服务对象接口实现
 */
@Slf4j
@Service("PFDeptServiceImpl")
public class PFDeptServiceImpl extends ServiceImpl<PFDeptMapper, PFDept> implements IPFDeptService {

    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMApplyService emapplyService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMAssetService emassetService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMENConsumService emenconsumService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQAHService emeqahService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQCheckService emeqcheckService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQDebugService emeqdebugService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQKeepService emeqkeepService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQMaintanceService emeqmaintanceService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQSetupService emeqsetupService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEquipService emequipService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMItemPUseService emitempuseService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMItemTradeService emitemtradeService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMJYJLService emjyjlService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPlanTemplService emplantemplService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPlanService emplanService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMProductService emproductService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPurchangeHisService empurchangehisService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_DPService emwoDpService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_ENService emwoEnService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_INNERService emwoInnerService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_OSCService emwoOscService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWOService emwoService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_PTService emwoPtService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWPListService emwplistService;

    private cn.ibizlab.eam.core.eam_pf.service.IPFDeptService pfdeptService = this;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_pf.service.IPFEmpPostMapService pfemppostmapService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_pf.service.IPFEmpService pfempService;

    private int batchSize = 500;

    @Override
    @Transactional
    public boolean save(PFDept et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(PFDept et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public void saveBatch(List<PFDept> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public boolean create(PFDept et) {
        fillParentData(et);
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getPfdeptid()),et);
        return true;
    }

    @Override
    public void createBatch(List<PFDept> list) {
        list.forEach(item->fillParentData(item));
        this.saveBatch(list,batchSize);
    }

    @Override
    public PFDept getDraft(PFDept et) {
        fillParentData(et);
        return et;
    }

    @Override
    @Transactional
    public PFDept get(String key) {
        PFDept et = getById(key);
        if(et==null){
            et=new PFDept();
            et.setPfdeptid(key);
        }
        else{
        }
        return et;
    }

    @Override
    @Transactional
    public boolean update(PFDept et) {
        fillParentData(et);
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("pfdeptid",et.getPfdeptid())))
            return false;
        CachedBeanCopier.copy(get(et.getPfdeptid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<PFDept> list) {
        list.forEach(item->fillParentData(item));
        updateBatchById(list,batchSize);
    }

    @Override
    public boolean checkKey(PFDept et) {
        return (!ObjectUtils.isEmpty(et.getPfdeptid()))&&(!Objects.isNull(this.getById(et.getPfdeptid())));
    }


	@Override
    public List<PFDept> selectByDeptpid(String pfdeptid) {
        return baseMapper.selectByDeptpid(pfdeptid);
    }

    @Override
    public void removeByDeptpid(String pfdeptid) {
        this.remove(new QueryWrapper<PFDept>().eq("deptpid",pfdeptid));
    }

	@Override
    public List<PFDept> selectByMgrempid(String pfempid) {
        return baseMapper.selectByMgrempid(pfempid);
    }

    @Override
    public void removeByMgrempid(String pfempid) {
        this.remove(new QueryWrapper<PFDept>().eq("mgrempid",pfempid));
    }


    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PFDept> searchDefault(PFDeptSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PFDept> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<PFDept>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }



    /**
     * 为当前实体填充父数据（外键值文本、外键值附加数据）
     * @param et
     */
    private void fillParentData(PFDept et){
        //实体关系[DER1N_PFDEPT_PFDEPT_DEPTPID]
        if(!ObjectUtils.isEmpty(et.getDeptpid())){
            cn.ibizlab.eam.core.eam_pf.domain.PFDept deptp=et.getDeptp();
            if(ObjectUtils.isEmpty(deptp)){
                cn.ibizlab.eam.core.eam_pf.domain.PFDept majorEntity=pfdeptService.get(et.getDeptpid());
                et.setDeptp(majorEntity);
                deptp=majorEntity;
            }
            et.setDeptpname(deptp.getPfdeptname());
        }
        //实体关系[DER1N_PFDEPT_PFEMP_MGREMPID]
        if(!ObjectUtils.isEmpty(et.getMgrempid())){
            cn.ibizlab.eam.core.eam_pf.domain.PFEmp mgremp=et.getMgremp();
            if(ObjectUtils.isEmpty(mgremp)){
                cn.ibizlab.eam.core.eam_pf.domain.PFEmp majorEntity=pfempService.get(et.getMgrempid());
                et.setMgremp(majorEntity);
                mgremp=majorEntity;
            }
            et.setMgrempname(mgremp.getPfempname());
        }
    }

    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

}


